]> git.proxmox.com Git - ceph.git/blobdiff - ceph/src/spdk/test/iscsi_tgt/fio/fio.sh
update sources to ceph Nautilus 14.2.1
[ceph.git] / ceph / src / spdk / test / iscsi_tgt / fio / fio.sh
index 57b74599ab47b8ef5fb79ee9fee108e1aff214fa..5fdeaed2dbd7abd97af6c2797f7d52f90b48e5c0 100755 (executable)
@@ -2,7 +2,13 @@
 
 testdir=$(readlink -f $(dirname $0))
 rootdir=$(readlink -f $testdir/../../..)
-source $rootdir/scripts/autotest_common.sh
+source $rootdir/test/common/autotest_common.sh
+source $rootdir/test/iscsi_tgt/common.sh
+
+delete_tmp_files() {
+       rm -f $testdir/iscsi.conf
+       rm -f ./local-job0-0-verify.state
+}
 
 function running_config() {
        # generate a config file from the running iscsi_tgt
@@ -14,14 +20,19 @@ function running_config() {
        # keep the same iscsiadm configuration to confirm that the
        #  config file matched the running configuration
        killprocess $pid
-       trap "iscsicleanup; exit 1" SIGINT SIGTERM EXIT
-       ./app/iscsi_tgt/iscsi_tgt -c /tmp/iscsi.conf &
+       trap "iscsicleanup; delete_tmp_files; exit 1" SIGINT SIGTERM EXIT
+
+       timing_enter start_iscsi_tgt2
+
+       $ISCSI_APP -c /tmp/iscsi.conf &
        pid=$!
        echo "Process pid: $pid"
-       trap "iscsicleanup; killprocess $pid; exit 1" SIGINT SIGTERM EXIT
-       waitforlisten $pid ${RPC_PORT}
+       trap "iscsicleanup; killprocess $pid; delete_tmp_files; exit 1" SIGINT SIGTERM EXIT
+       waitforlisten $pid
        echo "iscsi_tgt is listening. Running tests..."
 
+       timing_exit start_iscsi_tgt2
+
        sleep 1
        $fio_py 4096 1 randrw 5
 }
@@ -39,47 +50,48 @@ fi
 timing_enter fio
 
 cp $testdir/iscsi.conf.in $testdir/iscsi.conf
-$rootdir/scripts/gen_nvme.sh >> $testdir/iscsi.conf
-
-# iSCSI target configuration
-PORT=3260
-RPC_PORT=5260
-INITIATOR_TAG=2
-INITIATOR_NAME=ALL
-NETMASK=$INITIATOR_IP/32
+
 MALLOC_BDEV_SIZE=64
 MALLOC_BLOCK_SIZE=4096
 
-rpc_py="python $rootdir/scripts/rpc.py"
-fio_py="python $rootdir/scripts/fio.py"
+rpc_py="$rootdir/scripts/rpc.py"
+fio_py="$rootdir/scripts/fio.py"
+
+timing_enter start_iscsi_tgt
 
-./app/iscsi_tgt/iscsi_tgt -c $testdir/iscsi.conf &
+$ISCSI_APP -c $testdir/iscsi.conf &
 pid=$!
 echo "Process pid: $pid"
 
-trap "killprocess $pid; exit 1" SIGINT SIGTERM EXIT
+trap "killprocess $pid; rm -f $testdir/iscsi.conf; exit 1" SIGINT SIGTERM EXIT
 
-waitforlisten $pid ${RPC_PORT}
+waitforlisten $pid
 echo "iscsi_tgt is listening. Running tests..."
 
-$rpc_py add_portal_group 1 $TARGET_IP:$PORT
+timing_exit start_iscsi_tgt
+
+$rpc_py add_portal_group $PORTAL_TAG $TARGET_IP:$ISCSI_PORT
 $rpc_py add_initiator_group $INITIATOR_TAG $INITIATOR_NAME $NETMASK
-$rpc_py construct_malloc_bdev $MALLOC_BDEV_SIZE $MALLOC_BLOCK_SIZE
-# "Malloc0:0" ==> use Malloc0 blockdev for LUN0
+# Create a RAID-0 bdev from two malloc bdevs
+malloc_bdevs="$($rpc_py construct_malloc_bdev $MALLOC_BDEV_SIZE $MALLOC_BLOCK_SIZE) "
+malloc_bdevs+="$($rpc_py construct_malloc_bdev $MALLOC_BDEV_SIZE $MALLOC_BLOCK_SIZE)"
+$rpc_py construct_raid_bdev -n raid0 -s 64 -r 0 -b "$malloc_bdevs"
+# "raid0:0" ==> use raid0 blockdev for LUN0
 # "1:2" ==> map PortalGroup1 to InitiatorGroup2
 # "64" ==> iSCSI queue depth 64
-# "1 0 0 0" ==> disable CHAP authentication
-$rpc_py construct_target_node Target3 Target3_alias 'Malloc0:0' '1:2' 64 1 0 0 0
+# "-d" ==> disable CHAP authentication
+$rpc_py construct_target_node Target3 Target3_alias 'raid0:0' $PORTAL_TAG:$INITIATOR_TAG 64 -d
 sleep 1
 
-iscsiadm -m discovery -t sendtargets -p $TARGET_IP:$PORT
-iscsiadm -m node --login -p $TARGET_IP:$PORT
+iscsiadm -m discovery -t sendtargets -p $TARGET_IP:$ISCSI_PORT
+iscsiadm -m node --login -p $TARGET_IP:$ISCSI_PORT
 
-trap "iscsicleanup; killprocess $pid; exit 1" SIGINT SIGTERM EXIT
+trap "iscsicleanup; killprocess $pid; delete_tmp_files; exit 1" SIGINT SIGTERM EXIT
 
 sleep 1
 $fio_py 4096 1 randrw 1 verify
 $fio_py 131072 32 randrw 1 verify
+$fio_py 524288 128 randrw 1 verify
 
 if [ $RUN_NIGHTLY -eq 1 ]; then
        $fio_py 4096 1 write 300 verify
@@ -87,14 +99,44 @@ if [ $RUN_NIGHTLY -eq 1 ]; then
        # Run the running_config test which will generate a config file from the
        #  running iSCSI target, then kill and restart the iSCSI target using the
        #  generated config file
-       running_config
+       # Temporarily disabled
+       # running_config
 fi
 
-rm -f ./local-job0-0-verify.state
+# Start hotplug test case.
+$fio_py 1048576 128 rw 10 &
+fio_pid=$!
 
-trap - SIGINT SIGTERM EXIT
+sleep 3
+set +e
+# Delete raid0, Malloc0, Malloc1 blockdevs
+$rpc_py destroy_raid_bdev 'raid0'
+$rpc_py delete_malloc_bdev 'Malloc0'
+$rpc_py delete_malloc_bdev 'Malloc1'
+
+wait $fio_pid
+fio_status=$?
+
+if [ $fio_status -eq 0 ]; then
+       echo "iscsi hotplug test: fio successful - expected failure"
+       set -e
+       exit 1
+else
+       echo "iscsi hotplug test: fio failed as expected"
+fi
+
+set -e
 
 iscsicleanup
-rm -f $testdir/iscsi.conf
+$rpc_py delete_target_node 'iqn.2016-06.io.spdk:Target3'
+
+delete_tmp_files
+
+trap - SIGINT SIGTERM EXIT
+
 killprocess $pid
+#echo 1 > /sys/bus/pci/rescan
+#sleep 2
+$rootdir/scripts/setup.sh
+
 timing_exit fio